#ifndef __LOGGER_H
#define __LOGGER_H

enum LoggerLogLevel {LOGGER_ERROR, LOGGER_WARNING, LOGGER_INFO, LOGGER_DEBUG};

#define LOG_FILENAME_LENGTH_MAX 1024
#define LOG_ENTRY_MAXSIZE 131072

#include <iostream>
#include <fstream>
#include <stdarg.h>
//#include <vcclr.h>
#include <ctime>

class Logger
{
	private:   
		
    public:
        Logger(char * filename);   
        void log(LoggerLogLevel level,char * msg);
       
        //void Logger::logf(LoggerLogLevel level,char * fmt, ...array<System::Object^> ^args); 
		void Logger::logf(LoggerLogLevel level,char * fmt, ...); 
        char * Logger::LevelToStr(LoggerLogLevel l);
    public:   
   
        static Logger * Logger::getInstance() 
        {
	        static Logger * _inst = NULL;
	        if (NULL == _inst) {
		        _inst = new Logger("winhttp.log");
	        }
	        return _inst;
        }
    protected:   
	
    private:
      
        char file_name[LOG_FILENAME_LENGTH_MAX];
};


#endif